]> git.ipfire.org Git - thirdparty/git.git/blame - git-am.sh
git-fetch: allow updating the current branch in a bare repository.
[thirdparty/git.git] / git-am.sh
CommitLineData
d1c5f2a4
JH
1#!/bin/sh
2#
d64e6b04 3# Copyright (c) 2005, 2006 Junio C Hamano
d1c5f2a4 4
8273c79a
JH
5USAGE='[--signoff] [--dotest=<dir>] [--utf8] [--binary] [--3way]
6 [--interactive] [--whitespace=<option>] <mbox>...
cf1fe88c
FK
7 or, when resuming [--skip | --resolved]'
8. git-sh-setup
f9474132 9set_reflog_action am
d1c5f2a4 10
d64e6b04
JH
11git var GIT_COMMITTER_IDENT >/dev/null || exit
12
d1c5f2a4
JH
13stop_here () {
14 echo "$1" >"$dotest/next"
15 exit 1
16}
17
ced9456a 18stop_here_user_resolve () {
cc120056
SE
19 if [ -n "$resolvemsg" ]; then
20 echo "$resolvemsg"
21 stop_here $1
22 fi
ced9456a
RS
23 cmdline=$(basename $0)
24 if test '' != "$interactive"
25 then
26 cmdline="$cmdline -i"
27 fi
28 if test '' != "$threeway"
29 then
30 cmdline="$cmdline -3"
31 fi
32 if test '.dotest' != "$dotest"
33 then
34 cmdline="$cmdline -d=$dotest"
35 fi
36 echo "When you have resolved this problem run \"$cmdline --resolved\"."
37 echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
38
39 stop_here $1
40}
41
d1c5f2a4
JH
42go_next () {
43 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
44 "$dotest/patch" "$dotest/info"
45 echo "$next" >"$dotest/next"
46 this=$next
47}
48
fd7bcfb5
JH
49cannot_fallback () {
50 echo "$1"
51 echo "Cannot fall back to three-way merge."
52 exit 1
53}
54
d1c5f2a4
JH
55fall_back_3way () {
56 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
57
58 rm -fr "$dotest"/patch-merge-*
59 mkdir "$dotest/patch-merge-tmp-dir"
60
61 # First see if the patch records the index info that we can use.
fd7bcfb5
JH
62 git-apply -z --index-info "$dotest/patch" \
63 >"$dotest/patch-merge-index-info" &&
64 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
65 git-update-index -z --index-info <"$dotest/patch-merge-index-info" &&
66 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
67 git-write-tree >"$dotest/patch-merge-base+" ||
68 cannot_fallback "Patch does not record usable index information."
69
70 echo Using index info to reconstruct a base tree...
71 if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
b7627278 72 git-apply $binary --cached <"$dotest/patch"
d1c5f2a4 73 then
d1c5f2a4
JH
74 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
75 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
fd7bcfb5
JH
76 else
77 cannot_fallback "Did you hand edit your patch?
78It does not apply to blobs recorded in its index."
d1c5f2a4
JH
79 fi
80
81 test -f "$dotest/patch-merge-index" &&
82 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git-write-tree) &&
83 orig_tree=$(cat "$dotest/patch-merge-base") &&
84 rm -fr "$dotest"/patch-merge-* || exit 1
85
86 echo Falling back to patching base and 3-way merge...
87
88 # This is not so wrong. Depending on which base we picked,
89 # orig_tree may be wildly different from ours, but his_tree
90 # has the same set of wildly different changes in parts the
579c9bb1 91 # patch did not touch, so recursive ends up canceling them,
d1c5f2a4
JH
92 # saying that we reverted all those changes.
93
579c9bb1
SP
94 eval GITHEAD_$his_tree='"$SUBJECT"'
95 export GITHEAD_$his_tree
96 git-merge-recursive $orig_tree -- HEAD $his_tree || {
1536dd9c
JH
97 if test -d "$GIT_DIR/rr-cache"
98 then
99 git-rerere
100 fi
d1c5f2a4
JH
101 echo Failed to merge in the changes.
102 exit 1
103 }
579c9bb1 104 unset GITHEAD_$his_tree
d1c5f2a4
JH
105}
106
107prec=4
cc120056 108dotest=.dotest sign= utf8= keep= skip= interactive= resolved= binary= ws= resolvemsg=
d1c5f2a4
JH
109
110while case "$#" in 0) break;; esac
111do
112 case "$1" in
113 -d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
8096fae7 114 dotest=`expr "z$1" : 'z-[^=]*=\(.*\)'`; shift ;;
d1c5f2a4
JH
115 -d|--d|--do|--dot|--dote|--dotes|--dotest)
116 case "$#" in 1) usage ;; esac; shift
117 dotest="$1"; shift;;
118
119 -i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
120 --interacti|--interactiv|--interactive)
121 interactive=t; shift ;;
122
087b6742
JH
123 -b|--b|--bi|--bin|--bina|--binar|--binary)
124 binary=t; shift ;;
125
d1c5f2a4
JH
126 -3|--3|--3w|--3wa|--3way)
127 threeway=t; shift ;;
128 -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
129 sign=t; shift ;;
130 -u|--u|--ut|--utf|--utf8)
131 utf8=t; shift ;;
132 -k|--k|--ke|--kee|--keep)
133 keep=t; shift ;;
134
0c15cc92
JH
135 -r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
136 resolved=t; shift ;;
137
d1c5f2a4
JH
138 --sk|--ski|--skip)
139 skip=t; shift ;;
140
8c31cb82
JH
141 --whitespace=*)
142 ws=$1; shift ;;
143
cc120056
SE
144 --resolvemsg=*)
145 resolvemsg=$(echo "$1" | sed -e "s/^--resolvemsg=//"); shift ;;
146
d1c5f2a4
JH
147 --)
148 shift; break ;;
149 -*)
150 usage ;;
151 *)
152 break ;;
153 esac
154done
155
0c15cc92
JH
156# If the dotest directory exists, but we have finished applying all the
157# patches in them, clear it out.
d1c5f2a4
JH
158if test -d "$dotest" &&
159 last=$(cat "$dotest/last") &&
160 next=$(cat "$dotest/next") &&
161 test $# != 0 &&
162 test "$next" -gt "$last"
163then
164 rm -fr "$dotest"
165fi
166
167if test -d "$dotest"
168then
c95b1389
JH
169 case "$#,$skip$resolved" in
170 0,*t*)
171 # Explicit resume command and we do not have file, so
172 # we are happy.
173 : ;;
174 0,)
175 # No file input but without resume parameters; catch
176 # user error to feed us a patch from standard input
177 # when there is already .dotest. This is somewhat
178 # unreliable -- stdin could be /dev/null for example
179 # and the caller did not intend to feed us a patch but
180 # wanted to continue unattended.
181 tty -s
182 ;;
183 *)
184 false
185 ;;
186 esac ||
187 die "previous dotest directory $dotest still exists but mbox given."
271440e3 188 resume=yes
d1c5f2a4 189else
0c15cc92
JH
190 # Make sure we are not given --skip nor --resolved
191 test ",$skip,$resolved," = ,,, ||
cc120056 192 die "Resolve operation not in progress, we are not resuming."
d1c5f2a4
JH
193
194 # Start afresh.
195 mkdir -p "$dotest" || exit
196
b3f041fb 197 git-mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" || {
d1c5f2a4
JH
198 rm -fr "$dotest"
199 exit 1
200 }
201
8c31cb82
JH
202 # -b, -s, -u, -k and --whitespace flags are kept for the
203 # resuming session after a patch failure.
0c15cc92 204 # -3 and -i can and must be given when resuming.
087b6742 205 echo "$binary" >"$dotest/binary"
8c31cb82 206 echo " $ws" >"$dotest/whitespace"
d1c5f2a4
JH
207 echo "$sign" >"$dotest/sign"
208 echo "$utf8" >"$dotest/utf8"
209 echo "$keep" >"$dotest/keep"
d1c5f2a4
JH
210 echo 1 >"$dotest/next"
211fi
212
0c15cc92
JH
213case "$resolved" in
214'')
215 files=$(git-diff-index --cached --name-only HEAD) || exit
216 if [ "$files" ]; then
217 echo "Dirty index: cannot apply patches (dirty: $files)" >&2
218 exit 1
219 fi
220esac
221
087b6742
JH
222if test "$(cat "$dotest/binary")" = t
223then
224 binary=--allow-binary-replacement
225fi
d1c5f2a4
JH
226if test "$(cat "$dotest/utf8")" = t
227then
228 utf8=-u
229fi
230if test "$(cat "$dotest/keep")" = t
231then
232 keep=-k
233fi
8c31cb82 234ws=`cat "$dotest/whitespace"`
d1c5f2a4
JH
235if test "$(cat "$dotest/sign")" = t
236then
237 SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
238 s/>.*/>/
239 s/^/Signed-off-by: /'
240 `
241else
242 SIGNOFF=
243fi
d1c5f2a4
JH
244
245last=`cat "$dotest/last"`
246this=`cat "$dotest/next"`
247if test "$skip" = t
248then
f131dd49
EW
249 if test -d "$GIT_DIR/rr-cache"
250 then
251 git-rerere clear
252 fi
d1c5f2a4 253 this=`expr "$this" + 1`
69224716 254 resume=
d1c5f2a4
JH
255fi
256
257if test "$this" -gt "$last"
258then
259 echo Nothing to do.
260 rm -fr "$dotest"
261 exit
262fi
263
264while test "$this" -le "$last"
265do
266 msgnum=`printf "%0${prec}d" $this`
267 next=`expr "$this" + 1`
268 test -f "$dotest/$msgnum" || {
69224716 269 resume=
d1c5f2a4
JH
270 go_next
271 continue
272 }
0c15cc92
JH
273
274 # If we are not resuming, parse and extract the patch information
275 # into separate files:
276 # - info records the authorship and title
277 # - msg is the rest of commit log message
278 # - patch is the patch body.
279 #
280 # When we are resuming, these files are either already prepared
281 # by the user, or the user can tell us to do so by --resolved flag.
271440e3
JH
282 case "$resume" in
283 '')
284 git-mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
285 <"$dotest/$msgnum" >"$dotest/info" ||
286 stop_here $this
287 git-stripspace < "$dotest/msg" > "$dotest/msg-clean"
288 ;;
289 esac
d1c5f2a4
JH
290
291 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
292 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
293 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
e0e3ba20
JH
294
295 if test -z "$GIT_AUTHOR_EMAIL"
296 then
297 echo "Patch does not have a valid e-mail address."
298 stop_here $this
299 fi
300
2c674191 301 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
d1c5f2a4 302
4bfb6b62 303 SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
d1c5f2a4 304 case "$keep_subject" in -k) SUBJECT="[PATCH] $SUBJECT" ;; esac
4bfb6b62
JH
305
306 case "$resume" in
307 '')
308 if test '' != "$SIGNOFF"
309 then
d1c5f2a4 310 LAST_SIGNED_OFF_BY=`
4bfb6b62
JH
311 sed -ne '/^Signed-off-by: /p' \
312 "$dotest/msg-clean" |
313 tail -n 1
d1c5f2a4 314 `
4bfb6b62
JH
315 ADD_SIGNOFF=`
316 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
d1c5f2a4
JH
317 test '' = "$LAST_SIGNED_OFF_BY" && echo
318 echo "$SIGNOFF"
4bfb6b62
JH
319 }`
320 else
d1c5f2a4 321 ADD_SIGNOFF=
4bfb6b62
JH
322 fi
323 {
d1c5f2a4
JH
324 echo "$SUBJECT"
325 if test -s "$dotest/msg-clean"
326 then
327 echo
328 cat "$dotest/msg-clean"
329 fi
330 if test '' != "$ADD_SIGNOFF"
331 then
332 echo "$ADD_SIGNOFF"
333 fi
4bfb6b62
JH
334 } >"$dotest/final-commit"
335 ;;
0c15cc92 336 *)
6d28644d 337 case "$resolved$interactive" in
0c15cc92
JH
338 tt)
339 # This is used only for interactive view option.
340 git-diff-index -p --cached HEAD >"$dotest/patch"
341 ;;
342 esac
4bfb6b62 343 esac
d1c5f2a4 344
4bfb6b62 345 resume=
d1c5f2a4
JH
346 if test "$interactive" = t
347 then
a1451104
JH
348 test -t 0 ||
349 die "cannot be interactive without stdin connected to a terminal."
d1c5f2a4
JH
350 action=again
351 while test "$action" = again
352 do
353 echo "Commit Body is:"
354 echo "--------------------------"
355 cat "$dotest/final-commit"
356 echo "--------------------------"
9754563c 357 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
d1c5f2a4
JH
358 read reply
359 case "$reply" in
f89ad67f
JH
360 [yY]*) action=yes ;;
361 [aA]*) action=yes interactive= ;;
362 [nN]*) action=skip ;;
363 [eE]*) "${VISUAL:-${EDITOR:-vi}}" "$dotest/final-commit"
d1c5f2a4 364 action=again ;;
f89ad67f
JH
365 [vV]*) action=again
366 LESS=-S ${PAGER:-less} "$dotest/patch" ;;
367 *) action=again ;;
d1c5f2a4
JH
368 esac
369 done
370 else
371 action=yes
372 fi
373
374 if test $action = skip
375 then
376 go_next
377 continue
378 fi
379
380 if test -x "$GIT_DIR"/hooks/applypatch-msg
381 then
382 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
383 stop_here $this
384 fi
385
386 echo
387 echo "Applying '$SUBJECT'"
388 echo
389
0c15cc92
JH
390 case "$resolved" in
391 '')
8c31cb82 392 git-apply $binary --index $ws "$dotest/patch"
0c15cc92
JH
393 apply_status=$?
394 ;;
395 t)
396 # Resolved means the user did all the hard work, and
397 # we do not have to do any patch application. Just
398 # trust what the user has in the index file and the
399 # working tree.
400 resolved=
6d28644d
JH
401 changed="$(git-diff-index --cached --name-only HEAD)"
402 if test '' = "$changed"
403 then
64646d11 404 echo "No changes - did you forget to use 'git add'?"
ced9456a 405 stop_here_user_resolve $this
6d28644d 406 fi
c1d1128b
JH
407 unmerged=$(git-ls-files -u)
408 if test -n "$unmerged"
409 then
410 echo "You still have unmerged paths in your index"
64646d11 411 echo "did you forget to use 'git add'?"
ced9456a 412 stop_here_user_resolve $this
c1d1128b 413 fi
0c15cc92 414 apply_status=0
f131dd49
EW
415 if test -d "$GIT_DIR/rr-cache"
416 then
417 git rerere
418 fi
0c15cc92
JH
419 ;;
420 esac
421
d1c5f2a4
JH
422 if test $apply_status = 1 && test "$threeway" = t
423 then
73319032 424 if (fall_back_3way)
d1c5f2a4 425 then
73319032
JH
426 # Applying the patch to an earlier tree and merging the
427 # result may have produced the same tree as ours.
6d28644d 428 changed="$(git-diff-index --cached --name-only HEAD)"
73319032
JH
429 if test '' = "$changed"
430 then
431 echo No changes -- Patch already applied.
432 go_next
433 continue
434 fi
435 # clear apply_status -- we have successfully merged.
436 apply_status=0
d1c5f2a4
JH
437 fi
438 fi
439 if test $apply_status != 0
440 then
441 echo Patch failed at $msgnum.
ced9456a 442 stop_here_user_resolve $this
d1c5f2a4
JH
443 fi
444
445 if test -x "$GIT_DIR"/hooks/pre-applypatch
446 then
447 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
448 fi
449
450 tree=$(git-write-tree) &&
451 echo Wrote tree $tree &&
452 parent=$(git-rev-parse --verify HEAD) &&
453 commit=$(git-commit-tree $tree -p $parent <"$dotest/final-commit") &&
454 echo Committed: $commit &&
f9474132 455 git-update-ref -m "$GIT_REFLOG_ACTION: $SUBJECT" HEAD $commit $parent ||
d1c5f2a4
JH
456 stop_here $this
457
458 if test -x "$GIT_DIR"/hooks/post-applypatch
459 then
460 "$GIT_DIR"/hooks/post-applypatch
461 fi
462
463 go_next
464done
465
466rm -fr "$dotest"